#ifndef __KSCOSAPISTRUCT_H_INCLUDED_
#define __KSCOSAPISTRUCT_H_INCLUDED_
/**
* @file KSCosApiStruct.h
* @author kevin.shen
* systemKSTradeAPI
* companyKingstar
* history
* 2012/11/12	kevin.shen	 create
*/
#include "KSUserApiDataTypeEx.h"
#include "KSCosApiDataType.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

namespace KingstarAPI
{

///ʼ¼
struct CKSConditionalOrderInitInsert
{
    ///Ӫҵ
    TThostFtdcBrokerIDType BrokerID;
    ///Ͷߴ
    TThostFtdcInvestorIDType InvestorID;
    ///Լ
    TThostFtdcInstrumentIDType	InstrumentID;
    ///
    TThostFtdcExchangeIDType	ExchangeID;
    ///ͻ
    TThostFtdcClientIDType	ClientID;
    ///
    TThostFtdcDirectionType	Direction;
    ///ƽ־
    TThostFtdcOffsetFlagType	CombOffsetFlag;
    ///Ͷױ־
    TThostFtdcHedgeFlagType	CombHedgeFlag;
    ///
    TThostFtdcVolumeType	VolumeTotalOriginal;
    ///۸
    TThostFtdcPriceType	LimitPrice;
    ///۸
    TKSOrderPriceTypeType OrderPriceType;             
    ///
    TKSConditionalTypeType  ConditionalType;
    ///
    TThostFtdcPriceType ConditionalPrice;
    ///
    TKSConditionalOrderIDType	ConditionalOrderID;
    ///
    TThostFtdcVolumeType TriggeredTimes;
    ///
    TKSConditionalOrderType OrderType;
    ///Чʱ
    TThostFtdcTimeType  ActiveTime;
    ///ʧЧʱ
    TThostFtdcTimeType InActiveTime;
    ///Ҵ
    TThostFtdcCurrencyIDType    CurrencyID;
};

///޸
struct CKSConditionalOrderModify
{
    ///Ӫҵ
    TThostFtdcBrokerIDType BrokerID;
    ///Ͷߴ
    TThostFtdcInvestorIDType InvestorID;
    ///Լ
    TThostFtdcInstrumentIDType	InstrumentID;
    ///
    TThostFtdcExchangeIDType	ExchangeID;
    ///ͻ
    TThostFtdcClientIDType	ClientID;
    ///
    TThostFtdcDirectionType	Direction;
    ///ƽ־
    TThostFtdcOffsetFlagType	CombOffsetFlag;
    ///Ͷױ־
    TThostFtdcHedgeFlagType	CombHedgeFlag;
    ///
    TThostFtdcVolumeType	VolumeTotalOriginal;
    ///۸
    TThostFtdcPriceType	LimitPrice;
    ///۸
    TKSOrderPriceTypeType OrderPriceType;          
    ///
    TKSConditionalTypeType  ConditionalType;
    ///
    TThostFtdcPriceType ConditionalPrice;
    ///
    TKSConditionalOrderIDType	ConditionalOrderID;
    ///
    TThostFtdcVolumeType TriggeredTimes;
    ///
    TKSConditionalOrderType OrderType;
    ///Чʱ
    TThostFtdcTimeType  ActiveTime;
    ///ʧЧʱ
    TThostFtdcTimeType InActiveTime;
    ///Ҵ
    TThostFtdcCurrencyIDType    CurrencyID;
};

///ѯ
struct CKSConditionalOrderQuery
{
    ///Ӫҵ
    TThostFtdcBrokerIDType BrokerID;
    ///Ͷߴ
    TThostFtdcInvestorIDType InvestorID;
    ///
    TKSConditionalOrderIDType	ConditionalOrderID;
};

///ɾ
struct CKSConditionalOrderRemove
{
    ///Ӫҵ
    TThostFtdcBrokerIDType BrokerID;
    ///Ͷߴ
    TThostFtdcInvestorIDType InvestorID;
    ///
    TKSConditionalOrderIDType	ConditionalOrderID;
};

///ͣ򼤻
struct CKSConditionalOrderStateAlter
{
    ///Ӫҵ
    TThostFtdcBrokerIDType BrokerID;
    ///Ͷߴ
    TThostFtdcInvestorIDType InvestorID;
    ///
    TKSConditionalOrderIDType	ConditionalOrderID;
    ///ͣ򼤻־
    TKSConditionalOrderStateAlterType	ConditionalOrderStateAlter;
};

///ѡ
struct CKSConditionalOrderSelect
{
    ///Ӫҵ
    TThostFtdcBrokerIDType BrokerID;
    ///Ͷߴ
    TThostFtdcInvestorIDType InvestorID;
    ///
    TKSConditionalOrderIDType	ConditionalOrderID;
    ///ѡ
    TKSConditionalOrderSelectResultType SelectResult;
};


///Ϣ
struct CKSConditionalOrderRspResultField
{
    ///Ӫҵ
    TThostFtdcBrokerIDType BrokerID;
    ///Ͷߴ
    TThostFtdcInvestorIDType InvestorID;
    ///
    TKSConditionalOrderIDType	ConditionalOrderID;
};

///Ӧ
struct CKSConditionalOrderOperResultField
{
    ///Ӫҵ
    TThostFtdcBrokerIDType BrokerID;
    ///Ͷߴ
    TThostFtdcInvestorIDType InvestorID;
    ///
    TKSConditionalOrderIDType	ConditionalOrderID;
    ///ر
    TThostFtdcOrderLocalIDType	OrderLocalID;
    ///
    TThostFtdcExchangeIDType	ExchangeID;
    ///Լ
    TThostFtdcInstrumentIDType	InstrumentID;
    ///״̬
    TThostFtdcOrderStatusType	OrderStatus;
    ///ƽ־
    TThostFtdcOffsetFlagType	CombOffsetFlag;
    ///Ͷױ־
    TThostFtdcHedgeFlagType	CombHedgeFlag;
    ///
    TThostFtdcDirectionType	Direction;
    ///۸
    TThostFtdcPriceType	LimitPrice;
    ///
    TThostFtdcVolumeType	VolumeTotalOriginal;
    ///
    TThostFtdcTradeDateType	TradingDay;
    ///û
    TThostFtdcUserIDType	UserID;
    ///ʱ
    TThostFtdcTimeType	CancelTime;
    ///ͻ
    TThostFtdcClientIDType	ClientID;
    ///״̬
    TKSConditionalOrderStatusType ConditionalOrderStatus;
    ///Ϣ
    TThostFtdcErrorMsgType	ErrorMsg;
    ///۸
    TThostFtdcOrderPriceTypeType OrderPriceType;
    ///
    TThostFtdcVolumeType TriggeredTimes;
    ///
    TKSConditionalOrderType OrderType;
    ///ע
    TThostFtdcMemoType	Memo;
    ///Чʱ
    TThostFtdcTimeType  ActiveTime;
    ///ʧЧʱ
    TThostFtdcTimeType InActiveTime;
};

///¼ֹֹӯ
struct CKSProfitAndLossOrderInsert
{
    ///Ӫҵ
    TThostFtdcBrokerIDType BrokerID;
    ///Ͷߴ
    TThostFtdcInvestorIDType InvestorID;
    ///ر
    TThostFtdcOrderLocalIDType	OrderLocalID;
    ///ֹ
    TThostFtdcPriceType  StopLossPrice;
    ///ֹӯ
    TThostFtdcPriceType  TakeProfitPrice;
    ///ƽַʽ
    TKSCloseModeType CloseMode;
    //ƽַӼλƽַʽ=12ʱЧ
    TThostFtdcPriceType FiguresPrice;
    ///
    TThostFtdcExchangeIDType	ExchangeID;
    ///ҵԪ
    TThostFtdcBusinessUnitType	BusinessUnit;
    ///ӯ۵ķʽ
    TKSOffsetValueType OffsetValue;
    ///۸
    TKSSpringTypeType SpringType;
    ///ֹ
    TThostFtdcPriceType	FloatLimitPrice;
    ///ֹ𵥴
    TThostFtdcVolumeType TriggeredTimes;
    ///Ҵ
    TThostFtdcCurrencyIDType    CurrencyID;
};

///ɾֹֹӯ
struct CKSProfitAndLossOrderRemove
{
    ///Ӫҵ
    TThostFtdcBrokerIDType BrokerID;
    ///Ͷߴ
    TThostFtdcInvestorIDType InvestorID;
    ///ֹֹӯ
    TKSProfitAndLossOrderIDType ProfitAndLossOrderID;
    ///ر
    TThostFtdcOrderLocalIDType	OrderLocalID;
    ///
    TThostFtdcExchangeIDType	ExchangeID;
    ///ҵԪ
    TThostFtdcBusinessUnitType	BusinessUnit;
};

///ѯֹֹӯ
struct CKSProfitAndLossOrderQuery
{
    ///Ӫҵ
    TThostFtdcBrokerIDType BrokerID;
    ///Ͷߴ
    TThostFtdcInvestorIDType InvestorID;
    ///ֹֹӯ
    TKSProfitAndLossOrderIDType ProfitAndLossOrderID;
    ///ر
    TThostFtdcOrderLocalIDType	OrderLocalID;
    ///
    TThostFtdcExchangeIDType	ExchangeID;
    ///ҵԪ
    TThostFtdcBusinessUnitType	BusinessUnit;
};

///޸ֹֹӯ
struct CKSProfitAndLossOrderModify
{
    ///Ӫҵ
    TThostFtdcBrokerIDType BrokerID;
    ///Ͷߴ
    TThostFtdcInvestorIDType InvestorID;
    ///ֹֹӯ
    TKSProfitAndLossOrderIDType ProfitAndLossOrderID;
    ///ֹ
    TThostFtdcPriceType  StopLossPrice;
    ///ֹӯ
    TThostFtdcPriceType  TakeProfitPrice;
    ///ƽַʽ
    TKSCloseModeType CloseMode;
    //ƽַλƽַʽ=12ʱЧ
    TThostFtdcPriceType FiguresPrice;
    ///ӯ۵ķʽ
    TKSOffsetValueType OffsetValue;
    ///۸
    TKSSpringTypeType SpringType;
    ///ֹ
    TThostFtdcPriceType	FloatLimitPrice;
    ///
    TThostFtdcVolumeType TriggeredTimes;
};

///ֹֹӯɾ
struct CKSProfitAndLossOrderRemoveField
{
    ///Ӫҵ
    TThostFtdcBrokerIDType BrokerID;
    ///Ͷߴ
    TThostFtdcInvestorIDType InvestorID;
    ///ֹֹӯ
    TKSProfitAndLossOrderIDType ProfitAndLossOrderID;
};

///ֹֹӯ
struct CKSProfitAndLossOrderOperResultField
{
    ///Ӫҵ
    TThostFtdcBrokerIDType BrokerID;
    ///Ͷߴ
    TThostFtdcInvestorIDType InvestorID;
    ///ֹֹӯ
    TKSProfitAndLossOrderIDType ProfitAndLossOrderID;
    ///Ա
    TThostFtdcUserIDType	UserID;
    ///Ͷ
    TThostFtdcPartyNameType InvestorName;
    ///ر
    TThostFtdcOrderLocalIDType	OrderLocalID;
    ///ֹ
    TThostFtdcPriceType  StopLossPrice;
    ///ֹӯ
    TThostFtdcPriceType  TakeProfitPrice;
    ///ƽַʽ
    TKSCloseModeType CloseMode;
	///ƽַӼλƽַʽ=12ʱЧ
    TThostFtdcPriceType Figures;
    ///鴥ʱ¼
    TThostFtdcPriceType LastPrice;
    ///ֹֹӯʱ
    TThostFtdcTimeType	ProfitAndLossOrderFormTime;
     ///ʱ
    TThostFtdcTimeType	ConditionalOrderFormTime;
     ///ίеʱ
    TThostFtdcTimeType	OrderFormTime;
     ///ֹֹӯ״̬
    TKSConditionalOrderStatusType ProfitAndLossOrderStatus;
    ///
    TKSConditionalOrderIDType	ConditionalOrderID;
    ///
    TThostFtdcExchangeIDType	ExchangeID;
    ///ͻ
    TThostFtdcClientIDType	ClientID;
    ///Լ
    TThostFtdcInstrumentIDType	InstrumentID;
    ///ƽ־
    TThostFtdcOffsetFlagType	CombOffsetFlag;
    ///Ͷױ־
    TThostFtdcHedgeFlagType	CombHedgeFlag;
    ///
    TThostFtdcDirectionType	Direction;
    ///۸
    TThostFtdcPriceType	LimitPrice;
    ///
    TThostFtdcVolumeType	VolumeTotalOriginal;
    ///ӯ۵ķʽ
    TKSOffsetValueType OffsetValue;
    ///ҵԪ
    TThostFtdcBusinessUnitType	BusinessUnit;
    ///۸
    TKSSpringTypeType SpringType;
    ///ֹ
    TThostFtdcPriceType	FloatLimitPrice;
    ///ֳɽ۸
    TThostFtdcPriceType OpenTradePrice;
};

// ѡϢ
struct CKSCOSAskSelectField
{
    ///Ӫҵ
    TThostFtdcBrokerIDType BrokerID;   
    ///Ա
    TThostFtdcUserIDType	UserID;
    ///Ͷߴ
    TThostFtdcInvestorIDType InvestorID;
    ///
    TThostFtdcSequenceNoType	SequenceNo;
    ///
    TKSConditionalOrderIDType	ConditionalOrderID;
    ///ע
    TThostFtdcMemoType	Memo;
    ///ѡʽ
    TKSConditionalOrderSelectTypeType SelectType;
};

// ״̬Ϣ
struct CKSCOSStatusField
{
    ///Ӫҵ
    TThostFtdcBrokerIDType BrokerID;   
    ///Ա
    TThostFtdcUserIDType	UserID;
    ///Ͷߴ
    TThostFtdcInvestorIDType InvestorID;
    ///
    TThostFtdcSequenceNoType	SequenceNo;
    ///
    TKSConditionalOrderIDType	ConditionalOrderID;
    ///״̬
    TKSConditionalOrderStatusType ConditionalOrderStatus;
    ///ע
    TThostFtdcMemoType	Memo;
    ///ر
    TThostFtdcOrderLocalIDType	OrderLocalID;
    ///
    TThostFtdcExchangeIDType	ExchangeID;
    ///Լ
    TThostFtdcInstrumentIDType	InstrumentID;
    ///״̬
    TThostFtdcOrderStatusType	OrderStatus;
    ///ƽ־
    TThostFtdcOffsetFlagType	CombOffsetFlag;
    ///Ͷױ־
    TThostFtdcHedgeFlagType	CombHedgeFlag;
    ///
    TThostFtdcDirectionType	Direction;
    ///۸
    TThostFtdcPriceType	LimitPrice;
    ///
    TThostFtdcVolumeType	VolumeTotalOriginal;
    ///
    TThostFtdcTradeDateType	TradingDay;
    ///û
    TThostFtdcUserIDType	CancelUserID;
    ///ʱ
    TThostFtdcTimeType	CancelTime;
    ///ͻ
    TThostFtdcClientIDType	ClientID;
    ///ҵԪ
    TThostFtdcBusinessUnitType	BusinessUnit;
    ///
    TThostFtdcOrderSysIDType	OrderSysID;
    ///ɽ
    TThostFtdcVolumeType	VolumeTraded;
    ///ʣ
    TThostFtdcVolumeType	VolumeTotal;
    ///ίʱ
    TThostFtdcTimeType	InsertTime;
    ///ʱ
    TThostFtdcTimeType	ActiveTime;
    ///ɽ۸
    TThostFtdcPriceType	TradePrice;
    ///Ҵ
    TThostFtdcCurrencyIDType    CurrencyID;
};

// ֹֹӯ״̬Ϣ
struct CKSPLStatusField
{
    ///Ӫҵ
    TThostFtdcBrokerIDType BrokerID;   
    ///Ա
    TThostFtdcUserIDType	UserID;
    ///Ͷߴ
    TThostFtdcInvestorIDType InvestorID;
    ///
    TThostFtdcSequenceNoType	SequenceNo;
    ///ֹֹӯ
    TKSProfitAndLossOrderIDType	ProfitAndLossOrderID;
    ///ֹ
    TKSConditionalOrderIDType	StopLossOrderID;
    ///ֹӯ
    TKSConditionalOrderIDType	TakeProfitOrderID;
    ///ӯ״̬
    TKSConditionalOrderStatusType ProfitAndLossOrderStatus;
    ///ֹ
    TThostFtdcPriceType  StopLossPrice;
    ///ֹӯ
    TThostFtdcPriceType  TakeProfitPrice;
    ///ӯ۵ķʽ
    TKSOffsetValueType OffsetValue;
    ///ֳɽ۸
    TThostFtdcPriceType OpenTradePrice;
    ///ע
    TThostFtdcMemoType	Memo;
    ///ر
    TThostFtdcOrderLocalIDType	OrderLocalID;
    ///
    TThostFtdcExchangeIDType	ExchangeID;
    ///Լ
    TThostFtdcInstrumentIDType	InstrumentID;
    ///״̬
    TThostFtdcOrderStatusType	OrderStatus;
    ///ƽ־
    TThostFtdcOffsetFlagType	CombOffsetFlag;
    ///Ͷױ־
    TThostFtdcHedgeFlagType	CombHedgeFlag;
    ///
    TThostFtdcDirectionType	Direction;
    ///۸
    TThostFtdcPriceType	LimitPrice;
    ///
    TThostFtdcVolumeType	VolumeTotalOriginal;
    ///
    TThostFtdcTradeDateType	TradingDay;
    ///û
    TThostFtdcUserIDType	CancelUserID;
    ///ʱ
    TThostFtdcTimeType	CancelTime;
    ///ͻ
    TThostFtdcClientIDType	ClientID;
    ///ҵԪ
    TThostFtdcBusinessUnitType	BusinessUnit;
    ///
    TThostFtdcOrderSysIDType	OrderSysID;
    ///ɽ
    TThostFtdcVolumeType	VolumeTraded;
    ///ʣ
    TThostFtdcVolumeType	VolumeTotal;
    ///ίʱ
    TThostFtdcTimeType	InsertTime;
    ///ʱ
    TThostFtdcTimeType	ActiveTime;
    ///ɽ۸
    TThostFtdcPriceType	TradePrice;
    ///Ҵ
    TThostFtdcCurrencyIDType    CurrencyID;
};

}	// end of namespace KingstarAPI
#endif